if ("optparse" %in% row.names(installed.packages()) == FALSE){
  install.packages("optparse",repos="http://cran.us.r-project.org")
}
library(optparse)
library(Seurat)
library(readr)
library(Matrix)

#Get param inputs
option_list=list(
  make_option("--r",action="store",type='character',help="R data filename"),
  make_option("--o",action="store",type='character',help="Seurat object name"),
  make_option("--g",action="store",type='character',help="Seurat group ident")
)
opt=parse_args(OptionParser(option_list=option_list))
rm(option_list)

#Load Seurat R data file and cells and update
load(opt$r)
data <- get(opt$o)
rm(list=opt$o)
try(
  if (as.numeric(substring(data@version,1,1))<3){
    data <- UpdateSeuratObject(data)
  }
)
cells <- read.table("./cells.csv",quote="\"")

#Filter cells
data <- subset(data,cells=cells$V1)

#Write ident group file
write.table(data[[opt$g]],file=paste0("./group_",opt$g,".csv"),row.names=TRUE,col.names=FALSE,append=FALSE,sep=",")