if ("optparse" %in% row.names(installed.packages()) == FALSE){
  install.packages("optparse",repos="http://cran.us.r-project.org")
}
library(optparse)
library(readr)
library(ggplot2)
library(cowplot)

#Get param inputs
option_list=list(
  make_option("--g",action="store",type='character',help="Seurat group ident"),
  make_option("--t",action="store",type='logical',default=TRUE,help="tSNE calculated?"),
  make_option("--u",action="store",type='logical',default=FALSE,help="UMAP calculated?")
)
opt=parse_args(OptionParser(option_list=option_list))
rm(option_list)

#Load group
id <- read.csv(paste0("./group_",opt$g,".csv"),header=FALSE)
names(id)[2] <- opt$g

#Load dr and plot
if (opt$t == TRUE){
  dr.tsne <- read.csv(paste0("./dr_tSNE.csv"),header=TRUE)
  colnames(dr.tsne)[1] <- "Cells"
  dr.tsne <- merge(x=dr.tsne,y=id,by.x="Cells",by.y="V1",all.x=TRUE)
  if (!dir.exists("./tsne")){
    dir.create("./tsne")
  }
  png(paste0("./tsne/ClusterGroup_tSNE_",opt$g,".png"),width=500,height=500,bg="white")
  plot(ggplot(dr.tsne,aes_string(x="tSNE_1",y="tSNE_2",col=opt$g))+geom_point(size=2)+labs(col="ID")+theme_cowplot())
  dev.off()
}
if (opt$u == TRUE){
  dr.umap <- read.csv(paste0("./dr_UMAP.csv"),header=TRUE)
  colnames(dr.umap)[1] <- "Cells"
  dr.umap <- merge(x=dr.umap,y=id,by.x="Cells",by.y="V1",all.x=TRUE)
  if (!dir.exists("./umap")){
    dir.create("./umap")
  }
  png(paste0("./umap/ClusterGroup_UMAP_",opt$g,".png"),width=500,height=500,bg="white")
  plot(ggplot(dr.umap,aes_string(x="UMAP_1",y="UMAP_2",col=opt$g))+geom_point(size=2)+labs(col="ID")+theme_cowplot())
  dev.off()
}